{$O+,F+}
Unit Sorting;
Interface

uses Panels;

type CmpMinFunc=Function(var r1,r2:pcdirRec):boolean;

procedure LSortByName;
procedure LSortByExt;
procedure LSortByLen;
procedure RSortByName;
procedure RSortByExt;
procedure RSortByLen;
procedure GlobalSort;

Implementation

uses crt,rv,main;


Function Name(var r1,r2:pcdirRec):boolean; far;
begin
 Name:=r1.fName<r2.fName;
end;

Function Ext(var r1,r2:pcdirRec):boolean; far;
begin
 Ext:=r1.fext<r2.fext;
end;

Function Len(var r1,r2:pcdirRec):boolean; far;
begin
 Len:=r1.flength<r2.flength;
end;

Function FD(var r1,r2:pcdirRec):boolean; far;
begin
 FD:=r1.itdir>r2.itdir;{}
end;




Procedure LSort(t,b:integer; Cmp:CmpMinFunc);

Procedure QuickSort(l,r:integer);
var i,j:integer; x,y:pcdirRec;
begin
 i:=l;
 j:=r;
 x:=lp.pcdir^[(l+r) div 2];
 repeat
  while Cmp(lp.pcdir^[i],x) do inc(i);
  while Cmp(x,lp.pcdir^[j]) do dec(j);
  if i<=j
  then begin
        y:=lp.pcdir^[i];
        lp.pcdir^[i]:=lp.pcdir^[j];
        lp.pcdir^[j]:=y;
        inc(i);
        dec(j);
       end;
 until i>j;
 if l<j then QuickSort(l,j);
 if i<r then QuickSort(i,r);
end;

begin
 QuickSort(t,b);
end;





Procedure RSort(t,b:integer; Cmp:CmpMinFunc);

Procedure QuickSort(l,r:integer);
var i,j:integer; x,y:pcdirRec;
begin
 i:=l;
 j:=r;
 x:=rp.pcdir^[(l+r) div 2];
 repeat
  while Cmp(rp.pcdir^[i],x) do inc(i);
  while Cmp(x,rp.pcdir^[j]) do dec(j);
  if i<=j
  then begin
        y:=rp.pcdir^[i];
        rp.pcdir^[i]:=rp.pcdir^[j];
        rp.pcdir^[j]:=y;
        inc(i);
        dec(j);
       end;
 until i>j;
 if l<j then QuickSort(l,j);
 if i<r then QuickSort(i,r);
end;

begin
 QuickSort(t,b);
end;






procedure LSortByName;
var a,b:integer;
begin
 b:=1; {if lp.treec>1 then b:=2;{}

 LSort(b,lp.pctdirs+lp.pctfiles,FD);

 LSort(b,lp.pctdirs,Name);
 LSort(lp.pctdirs+1,lp.pctdirs+lp.pctfiles,Name);

 while b<=lp.pctdirs do{}
  begin
   a:=b;
   while (b<lp.pctdirs)and((lp.pcdir^[b+1].fname)=(lp.pcdir^[b].fname)) do begin inc(b); end;
   LSort(a,b,Ext);
   inc(a); inc(b);
  end;

 while b<=lp.pctdirs+lp.pctfiles do{}
  begin
   a:=b;
   while (b<lp.pctdirs+lp.pctfiles)and((lp.pcdir^[b+1].fname)=(lp.pcdir^[b].fname)) do begin inc(b); end;
   LSort(a,b,Ext);
   inc(a); inc(b);
  end;
end;

procedure LSortByExt;
var a,b:integer;
begin
 b:=1; {if lp.treec>1 then b:=2;{}

 LSort(b,lp.pctdirs+lp.pctfiles,FD);

 LSort(b,lp.pctdirs,Ext);
 LSort(lp.pctdirs+1,lp.pctdirs+lp.pctfiles,Ext);

 while b<=lp.pctdirs do{}
  begin
   a:=b;
   while (b<lp.pctdirs)and((lp.pcdir^[b+1].fext)=(lp.pcdir^[b].fext)) do begin inc(b); end;
   LSort(a,b,name);
   inc(a); inc(b);
  end;

 while b<=lp.pctdirs+lp.pctfiles do{}
  begin
   a:=b;
   while (b<lp.pctdirs+lp.pctfiles)and((lp.pcdir^[b+1].fext)=(lp.pcdir^[b].fext)) do begin inc(b); end;
   LSort(a,b,name);
   inc(a); inc(b);
  end;
end;

procedure LSortByLen;
var a,b:integer;
begin
 b:=1; {if lp.treec>1 then b:=2;{}
 LSort(b,lp.pctdirs+lp.pctfiles,FD);

 LSort(lp.pctdirs+1,lp.pctdirs+lp.pctfiles,Len);

 LSort(1,lp.pctdirs,Name);
end;

procedure RSortByName;
var a,b:integer;
begin
 b:=1; {if rp.treec>1 then b:=2;{}
 RSort(1,rp.pctdirs+rp.pctfiles,FD);

 RSort(b,rp.pctdirs,Name);
 RSort(rp.pctdirs+1,rp.pctdirs+rp.pctfiles,Name);

 while b<=rp.pctdirs do{}
  begin
   a:=b;
   while (b<rp.pctdirs)and((rp.pcdir^[b+1].fname)=(rp.pcdir^[b].fname)) do begin inc(b); end;
   RSort(a,b,Ext);
   inc(a); inc(b);
  end;

 while b<=rp.pctdirs+rp.pctfiles do{}
  begin
   a:=b;
   while (b<rp.pctdirs+rp.pctfiles)and((rp.pcdir^[b+1].fname)=(rp.pcdir^[b].fname)) do begin inc(b); end;
   RSort(a,b,Ext);
   inc(a); inc(b);
  end;
end;

procedure RSortByExt;
var a,b:integer;
begin
 b:=1; {if rp.treec>1 then b:=2;{}
 RSort(1,rp.pctdirs+rp.pctfiles,FD);{}

 RSort(b,rp.pctdirs,Ext);{}
 RSort(rp.pctdirs+1,rp.pctdirs+rp.pctfiles,Ext);

 while b<=rp.pctdirs do{}
  begin
   a:=b;
   while (b<rp.pctdirs)and((rp.pcdir^[b+1].fext)=(rp.pcdir^[b].fext)) do begin inc(b); end;
   RSort(a,b,name);
   inc(a); inc(b);
  end;

 while b<=rp.pctdirs+rp.pctfiles do{}
  begin
   a:=b;
   while (b<rp.pctdirs+rp.pctfiles)and((rp.pcdir^[b+1].fext)=(rp.pcdir^[b].fext)) do begin inc(b); end;
   RSort(a,b,name);
   inc(a); inc(b);
  end;
end;

procedure RSortByLen;
var a,b:integer;
begin
 b:=1; {if rp.treec>1 then b:=2;{}
 RSort(1,rp.pctdirs+rp.pctfiles,FD);

 RSort(rp.pctdirs+1,rp.pctdirs+rp.pctfiles,Len);

 RSort(1,rp.pctdirs,Name);
end;





procedure GlobalSort;
begin
case lp.sorttype of
 nametype: LSortByName;
  exttype: LSortByExt;
  lentype: LSortByLen;
end;

case rp.sorttype of
 nametype: RSortByName;
  exttype: RSortByExt;
  lentype: RSortByLen;
end;
end;





begin
end.
